/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** window_functions.c
 ** 
 ** Made by (Poindessous Thomas)
 ** Login   <poinde_t@epita.fr>
 ** 
 ** Started on  Mon May  3 20:06:30 1999 Poindessous Thomas
 ** Last update Fri Jul 30 01:19:56 1999 Thomas Poindessous
 */

#include "epiwm.h"

void	win_move(wg_tmp, x, y)
t_win	*wg_tmp;
int	x;
int	y;
{
  XMoveWindow(gl_dpy, wg_tmp->parent, x, y);
  clientSetState(wg_tmp, NormalState);
  send_configure_notify(wg_tmp);
}

void	win_resize(wg_tmp, width, height)
t_win	*wg_tmp;
int	width;
int	height;
{
  gl_event.xresizerequest.window = wg_tmp->win;
  gl_event.xresizerequest.width = width;
  gl_event.xresizerequest.height = height;
  resize_win();
}

void	win_shade(wg_tmp, dummy, dummy2)
t_win	*wg_tmp;
int	dummy;
int	dummy2;
{
  if ((wg_tmp->is_shade == 2) || (wg_tmp->is_shade == 3))
    internal_unshade(wg_tmp);
  else
    internal_shade(wg_tmp);   
}

void	win_sendto(wg_tmp, num_workspace, dummy)
t_win	*wg_tmp;
int	num_workspace;
int	dummy;
{
  
}

void	win_close(wg_tmp, dummy, dummy2)
t_win	*wg_tmp;
int	dummy;
int	dummy2;
{
  clientsendprotocol(wg_tmp, EPIWM_WM_DELETE_WINDOW);
}

void	win_destroy(wg_tmp, dummy, dummy2)
t_win	*wg_tmp;
int	dummy;
int	dummy2;
{
  XKillClient(gl_dpy, wg_tmp->win);
}

void	win_iconify(wg_tmp, dummy, dummy2)
t_win	*wg_tmp;
int	dummy;
int	dummy2;
{
  if (wg_tmp->iconify_title_win == 0)
    mouse_iconify(wg_tmp);
  else
    mouse_uniconify(wg_tmp);
}

